/*******************************************************************************
 * sshtrix - a very fast multithreaded SSH login cracker                       *
 *                                                                             *
 * report.c                                                                    *
 *                                                                             *
 * Copyright (C) 2011 noptrix - http://www.noptrix.net/                        *
 *                                                                             *
 * This program is free software: you can redistribute it and/or modify        *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * This program is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.       *
 *                                                                             *
 ******************************************************************************/

#include "report.h"


static void log_results(job_t *, FILE *);


/* log results either to stdout (default) or to given logfile */
static void log_results(job_t *job, FILE *fp)
{
    unsigned long int i = 0;


    printf("\n[+]"BLUE" game over"NORM"\n");

    if (job->list->num_found > 0) {
        printf("---\n"GREEN"FOUND LOGINS (host: %s port: %u)"NORM"\n---\n",
               job->target->host, job->target->port);
        for (i = 0; i < job->list->num_found; i++) {
            fprintf(fp, "%s - %s\n", job->list->found_users[i],
                    job->list->found_pass[i]);
        }
    } else {
        fprintf(fp, "---\nNO VALID LOGINS :(\n");
    }

    return;
}


/* make simple report */
job_t *report(job_t *job)
{
    FILE *fp = NULL;


    if (!job->logfile) {
        log_results(job, stdout);
    } else {
        fp = fopen(job->logfile, "a");
        log_results(job, fp);
        xfclose(fp);
        printf("[+] login pairs saved to \"%s\"\n", job->logfile);
    }

    return job;
}

/* EOF */
